#include <mutex>
#include "ros/ros.h"
#include "std_msgs/String.h"
#include "std_msgs/Empty.h"
#include "std_srvs/Empty.h"
#include "{{ pkgname }}/State.h"
#include "{{ pkgname }}/Transition.h"

class {{ skillset|capitalize }}ResourceManager {
private:
  ros::NodeHandle nh_;
  // Mutex
  std::mutex mutex_;
  ros::ServiceServer mutex_lock_srv_;
  ros::ServiceServer mutex_unlock_srv_;
  // Resources
  std_msgs::String state_msg;
  {% for res in resources %}
  std::string {{ res.name }}_state_;
  ros::Publisher {{ res.name }}_state_pub_;
  ros::ServiceServer {{ res.name }}_get_srv_;
  ros::ServiceServer {{ res.name }}_change_srv_;
  ros::ServiceServer {{ res.name }}_change_internal_srv_;
  {% endfor %}
  {% for res in resources %}
  bool {{ res.name }}_transition_exists(std::string target, bool use_extern) {
    (void)use_extern; // remove unused warning
    {%- for arc in res.statemachine.arcs %}
    if (this->{{ res.name }}_state_ == "{{ arc.src }}" && target == "{{ arc.dst }}")
      return {% if arc.extern %}use_extern{% else %}true{% endif %};
    {%- endfor %}
    return false;
  };

  bool change_{{ res.name }}_internal_state({{ pkgname }}::Transition::Request  &req,
           {{ pkgname }}::Transition::Response &res)
  {
    ROS_INFO("[resource_manager] received change request on {{ res.name }} to %s", req.target.c_str());
    if (this->{{ res.name }}_transition_exists(req.target, false)) {
      this->{{ res.name }}_state_ = req.target;
      this->state_msg.data = this->{{ res.name }}_state_;
      this->{{ res.name }}_state_pub_.publish(this->state_msg);
      res.success = true;
    }
    else {
      res.success = false;
    }
    res.state = this->{{ res.name }}_state_;
    return true;
  }

  bool change_{{ res.name }}_state({{ pkgname }}::Transition::Request  &req,
           {{ pkgname }}::Transition::Response &res)
  {
    const std::lock_guard<std::mutex> lock(this->mutex_);
    ROS_INFO("[resource_manager] received change request on {{ res.name }} to %s", req.target.c_str());
    if (this->{{ res.name }}_transition_exists(req.target, true)) {
      this->{{ res.name }}_state_ = req.target;
      this->state_msg.data = this->{{ res.name }}_state_;
      this->{{ res.name }}_state_pub_.publish(this->state_msg);
      res.success = true;
    }
    else {
      res.success = false;
    }
    res.state = this->{{ res.name }}_state_;
    return true;
  }

  bool get_{{ res.name }}_state({{ pkgname }}::State::Request  &req,
           {{ pkgname }}::State::Response &res)
  {
    (void)req; // remove unused warning
    ROS_DEBUG("[resource_manager] get_state of {{ res.name }}: %s", this->{{ res.name }}_state_.c_str());
    res.state = this->{{ res.name }}_state_;
    return true;
  }
  {% endfor %}

  // Mutex lock services
  bool mutex_lock(std_srvs::Empty::Request &req, std_srvs::Empty::Response &res) {
    (void)req; (void)res;
    ROS_INFO("[resource_manager] locking access to resources");
    this->mutex_.lock();
    ROS_INFO("[resource_manager] resource manager locked");
    return true;
  }
  bool mutex_unlock(std_srvs::Empty::Request &req, std_srvs::Empty::Response &res) {
    (void)req; (void)res;
    ROS_INFO("[resource_manager] unlocking access to resources");
    this->mutex_.unlock();
    ROS_INFO("[resource_manager] resource manager unlocked");
    return true;
  }
 

public:
  {{ skillset|capitalize }}ResourceManager() {
    this->mutex_lock_srv_ = this->nh_.advertiseService("resource/internal/lock",
      &{{ skillset|capitalize }}ResourceManager::mutex_lock, this);
    this->mutex_unlock_srv_ = this->nh_.advertiseService("resource/internal/unlock",
      &{{ skillset|capitalize }}ResourceManager::mutex_unlock, this);
    {% for res in resources %}
    ros::param::param<std::string>("~{{ res.name }}_initial_state", 
      this->{{ res.name }}_state_, "{{ res.statemachine.initial }}");
    this->{{ res.name }}_state_pub_ = this->nh_.advertise<std_msgs::String>("resource/{{ res.name }}_state", 1, true);
    this->{{ res.name }}_change_srv_ = this->nh_.advertiseService("resource/change_{{ res.name }}",
      &{{ skillset|capitalize }}ResourceManager::change_{{ res.name }}_state, this);
    this->{{ res.name }}_change_internal_srv_ = this->nh_.advertiseService("resource/internal/change_{{ res.name }}",
      &{{ skillset|capitalize }}ResourceManager::change_{{ res.name }}_internal_state, this);
    this->{{ res.name }}_get_srv_ = this->nh_.advertiseService("resource/get_{{ res.name }}",
      &{{ skillset|capitalize }}ResourceManager::get_{{ res.name }}_state, this);
    {% endfor %}
  }

};

int main(int argc, char **argv)
{
  ros::init(argc, argv, "resource_manager");
  {{ skillset|capitalize }}ResourceManager rm;
  ROS_INFO("[resource_manager] Resource Manager ready");

  int spinner_threads;
  ros::param::param<int>("~spinner_threads", 
    spinner_threads, 
    {{ number_skills }}+2);
  ROS_INFO_STREAM("[resource_manager] starts manager with " << spinner_threads << " threads");
  ros::MultiThreadedSpinner spinner(spinner_threads);
  spinner.spin();
  return 0;
}
